<?php

namespace Teknisa\ACL\Services;

use Doctrine\DBAL\DBALException;
use Exception;
use Teknisa\ACL\Util\InstanceProvider;
use Teknisa\ACL\Util\AclUtilities;
use Teknisa\ACL\Util\Messages;
use Teknisa\ACL\Repositories\Crud;
use Teknisa\Libs\Util\Utilities as LibUtilities;
use Zeedhi\Framework\Remote\FileUploader\Server;


class GrupoOperador {

    /**
     * @param $conditions
     * @param $cdoperador
     * @return array
     */
    public function findOpergrupop($conditions, $cdoperador): array
    {
        $grupoOperadorRepositorio = InstanceProvider::getRepository()->getGrupoOperador();
        $filter = AclUtilities::createQueryFiltered($conditions);
        return $grupoOperadorRepositorio->findOpergrupop($filter, $cdoperador);
    }

    /**
     * @param $idmenuprinop
     * @param $cdgrupoper
     * @param $cdoperador
     * @throws Exception
     */
    public function updateOpergrupop($idmenuprinop, $cdgrupoper, $cdoperador)
    {
        $grupoOperadorRepositorio = InstanceProvider::getRepository()->getGrupoOperador();
        $cdgrupoper = (string) $cdgrupoper;
        if (strlen($cdgrupoper) < 2) {
            $cdgrupoper = str_pad($cdgrupoper, 2, '0', STR_PAD_LEFT);
        }

        if ($idmenuprinop == 'S') {
            $opergrupop = $this->findOpergrupop(array(), $cdoperador);
            foreach ($opergrupop as $row) {
                if ($row['CDGRUPOPER'] === $cdgrupoper) {
                    $grupoOperadorRepositorio->updateOpergrupop('S', $row['CDGRUPOPER'], $row['CDOPERADOR']);
                } else if ($row['IDMENUPRINOP'] == 'S'){
                    $grupoOperadorRepositorio->updateOpergrupop('N', $row['CDGRUPOPER'], $row['CDOPERADOR']);
                }
            }
        } else {
            $grupoOperadorRepositorio->updateOpergrupop('N', $cdgrupoper, $cdoperador);
        }
    }

    /**
     * @param $cdoperador
     * @param $nrperfilacesso
     * @return array
     */
    public function findGrupooperByGrupopcont($cdoperador, $nrperfilacesso): array
    {
        $grupoOperadorRepositorio = InstanceProvider::getRepository()->getGrupoOperador();
        $idUtlPerfilfilial = InstanceProvider::getLibEnvironment()->getIdUtlPerfilFilial();
        if($idUtlPerfilfilial && $idUtlPerfilfilial != 'N') {
            return $grupoOperadorRepositorio->findGrupooperByGrupopcont($cdoperador, $nrperfilacesso);
        } else {
            return $grupoOperadorRepositorio->findGrupooperNotInOperGrupOp($cdoperador);
        }
    }

}
